\subsection{Explanation functions}

\begin{frame}{Explanation functions}
	\begin{definition}[Explanation function]
		Let $\A = \{x_1 \mapsto \alpha_1, \dots, x_k \mapsto \alpha_k \}$ and $C = \{c_1, \dots\}$ constraints over $x_1, \dots x_{k+1}$.

		Assume that $\centernot\exists \alpha_{k+1}. \{x_1 \mapsto \alpha_1, \dots x_{k+1} \mapsto \alpha_{k+1}\} \models C$.

		\pause
		An \emph{explanation function} constructs a lemma:
		\[
			C \rightarrow (\overline{x} \not\in \textrm{Cell around $\A$})
		\]\pause
		\[
			\textrm{Conflict in $\R^{k+1}$} \rightarrow \textrm{Lemma in $\R^k$}
		\]
	\end{definition}

	\pause
	We need to get rid of $x_{k+1}$: \emph{Quantifier elimination}

	\medskip
	\pause
	Model-based CAD \cite{Jovanovic2012}, Fourier-Motzkin \cite{Jovanovic2013}
\end{frame}

\begin{frame}{CAD-based / \NLSAT}
	\citefootline{\cite{Jovanovic2012}}

	\centering
	\includetikz{03b-mcsat-explanation-nlsat}
\end{frame}

\begin{frame}{Fourier-Motzkin \hfill{} \citethesis{Bartolome2018}}
	\citefootline{\cite{Jovanovic2013}}

	\begin{center}
		\includetikz{03b-mcsat-explanation-fm}
	\end{center}
	\visible<6->{
		\vspace*{-1.5em}
		\begin{itemize}
			\item Strict inequalities \hfill{} $2x_1 + 1 \emph{< x_2 <} x_1 + 2$ \quad $x_1 \mapsto 2$
			\item Disequalities \hfill{} $2x_1 + 1 \leq x_2 \leq x_1 + 2 \land \emph{x_2 \neq 3}$ \quad $x_1 \mapsto 1$
			\item Nonlinear coefficients \hfill{} $\emph{x_1^2+3} \leq x_2 \leq 2x_1$ \quad $x_1 \mapsto 1$
		\end{itemize}
	}
\end{frame}

\begin{frame}{Other explanation functions}
	\citefootline{\cite{Brown2013,Brown2015}}

	\begin{columns}
		\begin{column}{0.5\textwidth}
			Virtual cubstitution \hfill{} \citeown{Abraham2017}
			\begin{itemize}
				\item \emph{Nonlinear but low-degree}
				\item Flexible \emph{dimensionality} of generated cells
			\end{itemize}
			\pause
			OneCell \hfill{} \citethesis{Neuss2018}
			\begin{itemize}
				\item CAD tailored to construct \emph{a single cell}
				\item \emph{Larger cells} (and thus \emph{excludes more})
			\end{itemize}
		\end{column}
		\pause
		\begin{column}{0.5\textwidth}
			Interval constraint propagation
			\begin{itemize}
				\item \emph{Novel adaption} of ICP for MCSAT
				\item Disregards theory model
			\end{itemize}
			\pause
			Composition of explanation functions
			\begin{itemize}
				\item \SMTRAT: \emph{modular composition}
				\item \emph{Sequential} \& \emph{parallel}
			\end{itemize}
		\end{column}
	\end{columns}
	
	\visible<5->{
		\centering
		\includetikz{03c-mcsat-plot-explanations}
	}
\end{frame}
